#include <avr/io.h>
#include <avr/interrupt.h>
//Init PD5 and PD6 pins as output
void InitPort(void)
{
//set PD6/OC0A as output
DDRD|=(1<<PD6);
//set PB0 and PB1 as inputs
DDRB&=~((1<<PB0)|(1<<PB1));
//enable internal pullups
PORTB|=(1<<PB0)|(1<<PB1);
}
//Initialize Timer0
void InitTimer0(void)
{
//Set Initial Timer value
TCNT0=0;
//Place initial compare value to OCR0A
OCR0A=51;
//Set correct phase PWM mode
//and make clear OC0A when upcounting 
//and set when upcounting on compare match
TCCR0A|=(1<<COM0A1)|(1<<WGM00);
//emable OCR0A interrupt
TIMSK0|=(1<<OCIE0A);
}
void StartTimer0(void)
{
//Set prescaller 64 and start timer
TCCR0B|=(1<<CS01)|(1<<CS00);
//enable global interrupts
sei();
}
//use compare match interrupts to read buttons
//and update duty cycle
ISR(TIMER0_COMPA_vect)
{
//read UP button
if (!(PINB&(1<<PB0)))
	{
		//if not 100% duty cycle
		if (OCR0A<255)
		{
			//increment by 20%
			OCR0A+=51;
		}
	//wait for button release
	do { } while (!(PINB&(1<<PB0)));
	}
//read DOWN button
if (!(PINB&(1<<PB1)))
	{
		//if not 0% duty cycle
		if (OCR0A>0)
		{
			//decrement by 20%
			OCR0A-=51;
		}
	//wait for button release
	do { } while (!(PINB&(1<<PB1)));
	}
}
int main(void)
{
InitPort();
InitTimer0();
StartTimer0();
	while(1)
	{
		//doing nothing 	
	}
}
